//---------------------------------------------------------------------------
#ifndef dll16H
#define dll16H
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
//
//	TDLL16 : A Component for running 16-bit DLL functions.
//
//		Copyright (C) 1997 by Simon Chang
//
//	This component was written using information which I picked up from the
// 	following WWW sites:
//
//	[1] http://members.aol.com/delphimag/thunk95.htm
//  [2] http://www.ddj.com/ddsbk/1996/1996.03/pietrek.htm
//	[3] http://ftp.uni-mannheim.de/info/OReilly/windows/win95.update/dirty.html
//
//	Thanks also to BigCat, although in the end I used the approach discussed in
//	[3] for loading the Kernel32.dll undocumented function calls.
//
//	See README.TXT for help.
//
//---------------------------------------------------------------------------
class TDLL16 : public TComponent
{
private:
	TNotifyEvent  F_OnLoadLibrary;
    AnsiString    F_FileName;
    AnsiString	  F_TemplateFile;

    TList		  *L_Functions;
    THandle		  H_dll;
protected:
	__fastcall int GetNumFunctions();
    void * __fastcall GetFunction(int index);
	__fastcall void SetFileName(AnsiString A_FileName);
    __fastcall void SetTemplateFile(AnsiString A_TemplateFile);

    void CreateIncludeFiles();
	void Free_Functions();
    void LoadLib(char *LibName);
public:
	__fastcall TDLL16(TComponent* Owner);
    __fastcall ~TDLL16();
    void *CreateFunction(char *Template);

    __property int NumFunctions = {read = GetNumFunctions};
    __property void *Functions[int] = {read = GetFunction};
__published:
	__property TNotifyEvent OnLoadLibrary =
    					{read=F_OnLoadLibrary, write=F_OnLoadLibrary};
    __property AnsiString FileName =
    					{read=F_FileName, write=SetFileName};
	__property AnsiString TemplatesFile =
    					{read=F_TemplateFile, write=SetTemplateFile};
};
//---------------------------------------------------------------------------
class EDLL16Error : public Exception
{
	public:
    	EDLL16Error(char *msg) : Exception(msg) {}
};
//---------------------------------------------------------------------------
typedef unsigned short int16;
typedef int long16;
//---------------------------------------------------------------------------
#endif
